/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uqmconversation.domain;

import com.thoughtworks.xstream.annotations.XStreamAlias;
import java.util.ArrayList;
import uqmconversation.UQMConversationTool;

@XStreamAlias("CONVERSATION")
public class Conversation {
    private ArrayList<Dialog_Entry> dialogEntries;
    private Code code;


    public Conversation() {
        this.code = new Code();
        this.dialogEntries = new ArrayList<Dialog_Entry>();
    }
    



    public ArrayList<Dialog_Entry> getZelnickEntries() {
        ArrayList<Dialog_Entry> retarrs = new ArrayList<Dialog_Entry>();
        for (Dialog_Entry de : dialogEntries) {
            if (de.type == Dialog_Entry.E_dialogType.zelnick) {
                retarrs.add(de);
            }
        }
        return retarrs;
    }

    public ArrayList<Dialog_Entry> getAlienEntries() {
        ArrayList<Dialog_Entry> retarrs = new ArrayList<Dialog_Entry>();
        for (Dialog_Entry de : dialogEntries) {
            if (de.type == Dialog_Entry.E_dialogType.alien) {
                retarrs.add(de);
            }
        }
        return retarrs;
    }

    public ArrayList<Dialog_Entry> getDialogEntries() {
        return dialogEntries;
    }

    public Code getCode() {
        return code;
    }

    public void addDialogEntry(Dialog_Entry entry) {
        this.dialogEntries.add(entry);
    }

    public String generateStringsH() {
        String temp = "//Copyright Paul Reiche, Fred Ford. 1992-2002\n"
                + "//This file was generated by " + UQMConversationTool.TOOL_NAME_VERSION + "\n"
                + "\n"
                + "/*\n"
                + "*  This program is free software; you can redistribute it and/or modify\n"
                + "*  it under the terms of the GNU General Public License as published by\n"
                + "*  the Free Software Foundation; either version 2 of the License, or\n"
                + "*  (at your option) any later version.\n"
                + "*\n"
                + "*  This program is distributed in the hope that it will be useful,\n"
                + "*  but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
                + "*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
                + "*  GNU General Public License for more details.\n"
                + "*\n"
                + "*  You should have received a copy of the GNU General Public License\n"
                + "*  along with this program; if not, write to the Free Software\n"
                + "*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.\n"
                + "*/\n"
                + "\n"
                + "#ifndef _STRINGS_H\n"
                + "#define _STRINGS_H\n"
                + "\n"
                + "enum\n{\n"
                + "\tNULL_PHRASE,\n";

        int num = dialogEntries.size();
        for (Dialog_Entry de : dialogEntries) {
            if (num > 1) {
                temp += "\t" + de.dialogIdentifier + ",\n";
            } else {
                temp += "\t" + de.dialogIdentifier + "\n";
            }
            num--;
        }
        temp += "};\n"
                + "\n"
                + "#endif /* _STRINGS_H */\n\n";
        return temp;
    }

   
}
